unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, LZSS, StdCtrls, ExtCtrls;

type
    THeader = record
    Size: Word;
  end;
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    eStartAddress: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PackSize: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button3: TButton;
    Button4: TButton;
    Format: TRadioGroup;
    Big: TRadioButton;
    Little: TRadioButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  InFile, OutFile: TFileStream;
  InBuffer, OutBuffer: array of Byte;
  InSize, OutSize: LongWord;
  LZ: TLZ;
  Header: THeader;
  Address: Integer;
implementation

{$R *.dfm}
//***********Compression*************//
procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    InFile:= TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
    try
      InSize:= InFile.Size;
      SetLength(InBuffer, InSize);
      InFile.ReadBuffer(InBuffer[0], InSize);
      SetLength(OutBuffer, InSize);
      LZ:= TLZ.Create;
      OutSize:= LZ.Compress(InBuffer[0], Outbuffer[0], InSize, False, Big.Checked);

    finally
      InFile.Free;
      LZ.Free;
    end;
    if SaveDialog1.Execute then
    begin
      OutFile:= TFileStream.Create(SaveDialog1.FileName, fmCreate);
      try
        OutFile.WriteBuffer(OutBuffer[0], OutSize);
      finally
        OutFile.Free;
      end;
    end;
  end;
end;

//***********Decompression***********//
procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    InFile:= TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
    try
      Address:= StrToInt(eStartAddress.Text);
      InFile.Position:= Address;
      InSize:= InFile.Size - InFile.Position;
      if InSize > $FFFF then
        InSize:= $FFFF;
      SetLength(InBuffer, InSize);
      InFile.ReadBuffer(InBuffer[0], InSize);
      SetLength(OutBuffer, $FFFF);
      LZ:= TLZ.Create;
      if Big.Checked then
        OutSize:= (InBuffer[0] shl 8) or InBuffer[1]
      else
        OutSize:= (InBuffer[1] shl 8) or InBuffer[0];
      InSize:= LZ.Decompress(InBuffer[0], OutBuffer[0], False, Big.Checked);
    finally
      InFile.Free;
      LZ.Free;
    end;
    if SaveDialog1.Execute then
    begin
      OutFile:= TFileStream.Create(SaveDialog1.FileName, fmCreate);
      try
        OutFile.WriteBuffer(OutBuffer[0], OutSize);
      finally
        OutFile.Free;
      end;
    end;
  end;
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    InFile:= TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
    try
      InSize:= InFile.Size;
      SetLength(InBuffer, InSize);
      InFile.ReadBuffer(InBuffer[0], InSize);
      SetLength(OutBuffer, InSize);
      LZ:= TLZ.Create;
      OutSize:= LZ.Compress(InBuffer[0], Outbuffer[0], InSize, True, Big.Checked);
    finally
      InFile.Free;
      LZ.Free;
    end;
    if SaveDialog1.Execute then
    begin
      OutFile:= TFileStream.Create(SaveDialog1.FileName, fmCreate);
      try
        OutFile.WriteBuffer(OutBuffer[0], OutSize);
      finally
        OutFile.Free;
      end;
    end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    InFile:= TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
    try
      Address:= StrToInt(eStartAddress.Text);
      InFile.Position:= Address;
      InSize:= InFile.Size - InFile.Position;
      if InSize > $FFFF then
        InSize:= $FFFF;
      SetLength(InBuffer, InSize);
      InFile.ReadBuffer(InBuffer[0], Length(InBuffer));
      OutSize:= StrToInt(PackSize.Text);
      SetLength(OutBuffer, OutSize);
      LZ:= TLZ.Create;
      InSize:= LZ.Decompress(InBuffer[0], OutBuffer[0], True, Big.Checked);
    finally
      InFile.Free;
      LZ.Free;
    end;
    if SaveDialog1.Execute then
    begin
      OutFile:= TFileStream.Create(SaveDialog1.FileName, fmCreate);
      try
        OutFile.WriteBuffer(OutBuffer[0], Length(OutBuffer));
      finally
        OutFile.Free;
      end;
    end;
  end;
end;

end.
